
import matplotlib.pyplot as plt

# Data for the three graphs
metrics = ['Manhattan', 'Euclidean (Modified)', 'Diagonal']

# Graph 1: PathCounter / searchRange
path_counter_searchrange = [4641.273504, 104514.3485, 617122.9289]

# Graph 2: searchRange / IDAstar
searchrange_idastar = [117 / 0.1, 264 / 5.09, 239 / 28.83]

# Graph 3: PathCounter / IDAstar
path_counter_idastar = [5430290.0, 5420783.5, 5115934.1]

# Create a new figure with pleasing dark colors for the lines
plt.figure(figsize=(12, 10))

# Graph 1: PathCounter / searchRange
plt.subplot(2, 2, 1)
plt.plot(metrics, path_counter_searchrange, marker='o', color='darkblue', linestyle='-', linewidth=2, markersize=8)
plt.title('PathCounter / searchRange', fontsize=14, fontweight='bold')
plt.xlabel('Metrics', fontsize=12)
plt.ylabel('PathCounter / searchRange', fontsize=12)
plt.grid(True)

# Graph 2: searchRange / IDAstar
plt.subplot(2, 2, 2)
plt.plot(metrics, searchrange_idastar, marker='o', color='darkgreen', linestyle='-', linewidth=2, markersize=8)
plt.title('searchRange / IDAstar', fontsize=14, fontweight='bold')
plt.xlabel('Metrics', fontsize=12)
plt.ylabel('searchRange / IDAstar', fontsize=12)
plt.grid(True)

# Graph 3: PathCounter / IDAstar
plt.subplot(2, 1, 2)
plt.plot(metrics, path_counter_idastar, marker='o', color='darkslategray', linestyle='-', linewidth=2, markersize=8)
plt.title('PathCounter / IDAstar for Different Metrics', fontsize=14, fontweight='bold')
plt.xlabel('Metrics', fontsize=12)
plt.ylabel('PathCounter / IDAstar', fontsize=12)
plt.grid(True)

# Adjust layout
plt.tight_layout()

# Show the graphs
plt.show()