// Create a new scene
var scene = PADrend.createNewSceneRoot("new MinSG.ListNode");

// activate the scene
PADrend.selectScene(scene);

// Create the ground -----------------------------------------------------------
var vd = new Rendering.VertexDescription;
vd.appendPosition3D(); // 3xfloat (x,y,z)
vd.appendNormalByte(); // 4xbyte (x,y,z,0)
vd.appendColorRGBAByte(); // 4xbyte (r,g,b,a)

var grid = Rendering.createHexGrid(vd, 30, 30, 32, 32);

var scale = 10;
var transform = (new Geometry.Matrix4x4).scale(0.01, 0.01, 0.01); // scale matrix
 Rendering.calculateNormals(grid);

var gridNode = new MinSG.GeometryNode(grid);

var stateGrid = new MinSG.MaterialState;
stateGrid.setAmbient(new Util.Color4f(0.16, 0.47, 0.19, 1));
stateGrid.setDiffuse(new Util.Color4f(0.16, 0.47, 0.19, 1));

gridNode += stateGrid;
scene += gridNode;


// Create obstacles ------------------------------------------------------------
var stateCube = new MinSG.MaterialState;
stateCube.setAmbient(new Util.Color4f(0.96, 0.47, 0.19, 1));
stateCube.setDiffuse(new Util.Color4f(0.96, 0.47, 0.19, 1));

// First set of cubes
var cubeMesh = Rendering.createCube();
var geoNode = new MinSG.GeometryNode();
geoNode.moveLocal(2, 0, 10); // Starting point for the first cube
geoNode.scale(6); // Reduced scale to 4
geoNode.setMesh(cubeMesh);
geoNode += stateCube;
scene += geoNode;

var cubeMesh2 = Rendering.createCube();
var geoNode2 = new MinSG.GeometryNode();
geoNode2.moveLocal(6, 0, 10); // Adjusted x position by 4 units for the second cube
geoNode2.scale(4);
geoNode2.setMesh(cubeMesh2);
geoNode2 += stateCube;
scene += geoNode2;

var cubeMesh3 = Rendering.createCube();
var geoNode3 = new MinSG.GeometryNode();
geoNode3.moveLocal(10, 0, 10); // Adjusted x position by 4 units for the third cube
geoNode3.scale(4);
geoNode3.setMesh(cubeMesh3);
geoNode3 += stateCube;
scene += geoNode3;

var cubeMesh4 = Rendering.createCube();
var geoNode4 = new MinSG.GeometryNode();
geoNode4.moveLocal(14, 0, 10); // Adjusted x position by 4 units for the fourth cube
geoNode4.scale(4);
geoNode4.setMesh(cubeMesh4);
geoNode4 += stateCube;
scene += geoNode4;


// Second set of cubes



var cubeMesh5 = Rendering.createCube();
var geoNode5 = new MinSG.GeometryNode();
geoNode5.moveLocal(25, 0, 16);
geoNode5.scale(4);
geoNode5.setMesh(cubeMesh5);
geoNode5 += stateCube;
scene += geoNode5;

var cubeMesh6 = Rendering.createCube();
var geoNode6 = new MinSG.GeometryNode();
geoNode6.moveLocal(21, 0, 16);
geoNode6.scale(4);
geoNode6.setMesh(cubeMesh6);
geoNode6 += stateCube;
scene += geoNode6;

var cubeMesh7 = Rendering.createCube();
var geoNode7 = new MinSG.GeometryNode();
geoNode7.moveLocal(16, 0, 16);
geoNode7.scale(4);
geoNode7.setMesh(cubeMesh7);
geoNode7 += stateCube;
scene += geoNode7;

var cubeMesh8 = Rendering.createCube();
var geoNode8 = new MinSG.GeometryNode();
geoNode8.moveLocal(29, 0, 16);
geoNode8.scale(4);
geoNode8.setMesh(cubeMesh8);
geoNode8 += stateCube;
scene += geoNode8;

// Third set of cubes
var cubeMesh9 = Rendering.createCube();
var geoNode9 = new MinSG.GeometryNode();
geoNode9.moveLocal(4, 0, 22); // Starting point for the first cube in the third set
geoNode9.scale(4);
geoNode9.setMesh(cubeMesh9);
geoNode9 += stateCube;
scene += geoNode9;

var cubeMesh10 = Rendering.createCube();
var geoNode10 = new MinSG.GeometryNode();
geoNode10.moveLocal(8, 0, 22); // Adjusted x position by 4 units for the second cube
geoNode10.scale(4);
geoNode10.setMesh(cubeMesh10);
geoNode10 += stateCube;
scene += geoNode10;

var cubeMesh11 = Rendering.createCube();
var geoNode11 = new MinSG.GeometryNode();
geoNode11.moveLocal(12, 0, 22); // Adjusted x position by 4 units for the third cube
geoNode11.scale(4);
geoNode11.setMesh(cubeMesh11);
geoNode11 += stateCube;
scene += geoNode11;

var cubeMesh12 = Rendering.createCube();
var geoNode12 = new MinSG.GeometryNode();
geoNode12.moveLocal(16, 0, 22); // Adjusted x position by 4 units for the fourth cube
geoNode12.scale(4);
geoNode12.setMesh(cubeMesh12);
geoNode12 += stateCube;
scene += geoNode12;
// Call the algorithm ----------------------------------------------------------
//Pathfinder.disableOutput();
//Pathfinder.disableOBJ();
//Pathfinder.disableLogging();
var start = new Geometry.Vec3(14, 0, 2);
var goal = new Geometry.Vec3(14, 0, 29);
var path = Pathfinder.findPath(scene, start, goal, 1);
Pathfinder.enableOutput();

if(path.count() == 0) {
	path = [start, goal];
}


// Draw the found path ---------------------------------------------------------
var stateStart = new MinSG.MaterialState;
stateStart.setAmbient(new Util.Color4f(0, 1, 0, 1));
stateStart.setDiffuse(new Util.Color4f(0, 1, 0, 1));

var startMesh = Rendering.createCube();
var startGeoNode = new MinSG.GeometryNode();
startGeoNode.moveLocal(path[0]);
startGeoNode.scale(1);
startGeoNode.setMesh(startMesh);
startGeoNode += stateStart;
scene += startGeoNode;

var stateNode = new MinSG.MaterialState;
stateNode.setAmbient(new Util.Color4f(1, 0, 0, 1));
stateNode.setDiffuse(new Util.Color4f(1, 0, 0, 1));

for(var i = 1; i < path.count() - 1; ++i) {
	var nodeMesh = Rendering.createCube();
	var nodeGeoNode = new MinSG.GeometryNode();
	nodeGeoNode.moveLocal(path[i]);
	nodeGeoNode.scale(0.25);
	nodeGeoNode.setMesh(nodeMesh);
	nodeGeoNode += stateNode;
	scene += nodeGeoNode;

	var lineMesh = Rendering.createLine(vd, path[i-1], path[i]);
	var lineGeoNode = new MinSG.GeometryNode();
	lineGeoNode.setMesh(lineMesh);
	lineGeoNode += stateNode;
	scene += lineGeoNode;
}

var nodeMesh = Rendering.createCube();
var nodeGeoNode = new MinSG.GeometryNode();
nodeGeoNode.moveLocal(path[path.count()-1]);
nodeGeoNode.scale(1);
nodeGeoNode.setMesh(nodeMesh);
nodeGeoNode += stateNode;
scene += nodeGeoNode;

var lineMesh = Rendering.createLine(vd, path[path.count()-2], path[path.count()-1]);
var lineGeoNode = new MinSG.GeometryNode();
lineGeoNode.setMesh(lineMesh);
lineGeoNode += stateNode;
scene += lineGeoNode;


// Camera ----------------------------------------------------------------------
var camera = PADrend.getDolly();
camera.setWorldOrigin(new Geometry.Vec3(30,15,15));
camera.rotateToWorldDir(new Geometry.Vec3(90,90,0));
