// Create a new scene
var scene = PADrend.createNewSceneRoot("new MinSG.ListNode");

// activate the scene
PADrend.selectScene(scene);

// Create the ground -----------------------------------------------------------
var vd = new Rendering.VertexDescription;
vd.appendPosition3D(); // 3xfloat (x,y,z)
vd.appendNormalByte(); // 4xbyte (x,y,z,0)
vd.appendColorRGBAByte(); // 4xbyte (r,g,b,a)

var grid = Rendering.createHexGrid(vd, 50, 50, 50, 50);

var scale = 10;
var transform = (new Geometry.Matrix4x4).scale(0.01, 0.01, 0.01); // scale matrix
//for(var i = 0; i < 8; ++i) {
//  Rendering.applyNoise(grid, scale *= 0.45, transform.scale(2, 2, 2));
//}
Rendering.calculateNormals(grid);

var gridNode = new MinSG.GeometryNode(grid);

var stateGrid = new MinSG.MaterialState;
stateGrid.setAmbient(new Util.Color4f(0.16, 0.47, 0.19, 1));
stateGrid.setDiffuse(new Util.Color4f(0.16, 0.47, 0.19, 1));

gridNode += stateGrid;
scene += gridNode;


// Create obstacles ------------------------------------------------------------
var stateCube = new MinSG.MaterialState;
stateCube.setAmbient(new Util.Color4f(0.96, 0.47, 0.19, 1));
stateCube.setDiffuse(new Util.Color4f(0.96, 0.47, 0.19, 1));

// Obstacle 1
// var cubeMesh1 = Rendering.createCube();
// var geoNode1 = new MinSG.GeometryNode();
// geoNode1.moveLocal(4.45, 0, 10);//
// geoNode1.scale(4);
// geoNode1.setMesh(cubeMesh1);
// geoNode1 += stateCube;
// scene += geoNode1;

// Obstacle 2
// var cubeMesh2 = Rendering.createCube();
// var geoNode2 = new MinSG.GeometryNode();
// geoNode2.moveLocal(9, 0, 12);
// geoNode2.scale(6);
// geoNode2.setMesh(cubeMesh2);
// geoNode2 += stateCube;
// scene += geoNode2;

// Obstacle 3
var cubeMesh3 = Rendering.createCube();
var geoNode3 = new MinSG.GeometryNode();
geoNode3.moveLocal(15, 0, 14);
geoNode3.scale(6);
geoNode3.setMesh(cubeMesh3);
geoNode3 += stateCube;
scene += geoNode3;

// Obstacle 4
//var cubeMesh4 = Rendering.createCube();
//var geoNode4 = new MinSG.GeometryNode();
//geoNode4.moveLocal(21, 0, 16);
//geoNode4.scale(6);
//geoNode4.setMesh(cubeMesh4);
//geoNode4 += stateCube;
//scene += geoNode4;

// Obstacle 5
var cubeMesh5 = Rendering.createCube();
var geoNode5 = new MinSG.GeometryNode();
geoNode5.moveLocal(27, 0, 18);
geoNode5.scale(5);
geoNode5.setMesh(cubeMesh5);
geoNode5 += stateCube;
scene += geoNode5;

// Obstacle 6
var cubeMesh6 = Rendering.createCube();
var geoNode6 = new MinSG.GeometryNode();
geoNode6.moveLocal(33, 0, 20);
geoNode6.scale(5);
geoNode6.setMesh(cubeMesh6);
geoNode6 += stateCube;
scene += geoNode6;

// Obstacle 7
var cubeMesh7 = Rendering.createCube();
var geoNode7 = new MinSG.GeometryNode();
geoNode7.moveLocal(39, 0, 22);
geoNode7.scale(5);
geoNode7.setMesh(cubeMesh7);
geoNode7 += stateCube;
scene += geoNode7;

// Obstacle 8
var cubeMesh8 = Rendering.createCube();
var geoNode8 = new MinSG.GeometryNode();
geoNode8.moveLocal(45, 0, 24);
geoNode8.scale(5);
geoNode8.setMesh(cubeMesh8);
geoNode8 += stateCube;
scene += geoNode8;

// Obstacle 9
var cubeMesh9 = Rendering.createCube();
var geoNode9 = new MinSG.GeometryNode();
geoNode9.moveLocal(51, 0, 26);
geoNode9.scale(4);
geoNode9.setMesh(cubeMesh9);
geoNode9 += stateCube;
scene += geoNode9;

// Obstacle 10
var cubeMesh10 = Rendering.createCube();
var geoNode10 = new MinSG.GeometryNode();
geoNode10.moveLocal(3.45, 0, 28);
geoNode10.scale(4);
geoNode10.setMesh(cubeMesh10);
geoNode10 += stateCube;
scene += geoNode10;

// Obstacle 11
var cubeMesh11 = Rendering.createCube();
var geoNode11 = new MinSG.GeometryNode();
geoNode11.moveLocal(9, 0, 30);
geoNode11.scale(4);
geoNode11.setMesh(cubeMesh11);
geoNode11 += stateCube;
scene += geoNode11;

// Obstacle 12
var cubeMesh12 = Rendering.createCube();
var geoNode12 = new MinSG.GeometryNode();
geoNode12.moveLocal(15, 0, 32);
geoNode12.scale(4);
geoNode12.setMesh(cubeMesh12);
geoNode12 += stateCube;
scene += geoNode12;

// Obstacle 13
var cubeMesh13 = Rendering.createCube();
var geoNode13 = new MinSG.GeometryNode();
geoNode13.moveLocal(21, 0, 34);
geoNode13.scale(3);
geoNode13.setMesh(cubeMesh13);
geoNode13 += stateCube;
scene += geoNode13;

// Obstacle 14
var cubeMesh14 = Rendering.createCube();
var geoNode14 = new MinSG.GeometryNode();
geoNode14.moveLocal(27, 0, 36);
geoNode14.scale(3);
geoNode14.setMesh(cubeMesh14);
geoNode14 += stateCube;
scene += geoNode14;

// Obstacle 15
var cubeMesh15 = Rendering.createCube();
var geoNode15 = new MinSG.GeometryNode();
geoNode15.moveLocal(33, 0, 38);
geoNode15.scale(3);
geoNode15.setMesh(cubeMesh15);
geoNode15 += stateCube;
scene += geoNode15;

// Obstacle 16
var cubeMesh16 = Rendering.createCube();
var geoNode16 = new MinSG.GeometryNode();
geoNode16.moveLocal(39, 0, 40);
geoNode16.scale(3);
geoNode16.setMesh(cubeMesh16);
geoNode16 += stateCube;
scene += geoNode16;

// Obstacle 17
var cubeMesh17 = Rendering.createCube();
var geoNode17 = new MinSG.GeometryNode();
geoNode17.moveLocal(45, 0, 42);
geoNode17.scale(2);
geoNode17.setMesh(cubeMesh17);
geoNode17 += stateCube;
scene += geoNode17;

// Obstacle 18
var cubeMesh18 = Rendering.createCube();
var geoNode18 = new MinSG.GeometryNode();
geoNode18.moveLocal(51, 0, 44);
geoNode18.scale(2);
geoNode18.setMesh(cubeMesh18);
geoNode18 += stateCube;
scene += geoNode18;

// Obstacle 19
var cubeMesh19 = Rendering.createCube();
var geoNode19 = new MinSG.GeometryNode();
geoNode19.moveLocal(3.45, 0, 46);
geoNode19.scale(2);
geoNode19.setMesh(cubeMesh19);
geoNode19 += stateCube;
scene += geoNode19;

// Obstacle 20
var cubeMesh20 = Rendering.createCube();
var geoNode20 = new MinSG.GeometryNode();
geoNode20.moveLocal(9, 0, 48);
geoNode20.scale(2);
geoNode20.setMesh(cubeMesh20);
geoNode20 += stateCube;
scene += geoNode20;

// Call the algorithm ----------------------------------------------------------
//Pathfinder.disableOutput();
//Pathfinder.disableOBJ();
//Pathfinder.disableLogging();
var start = new Geometry.Vec3(10, 0, 0);
var goal = new Geometry.Vec3(50, 0, 50);
var path = Pathfinder.findPath(scene, start, goal, 0);
Pathfinder.enableOutput();

if(path.count() == 0) {
	path = [start, goal];
}


// Draw the found path ---------------------------------------------------------
var stateStart = new MinSG.MaterialState;
stateStart.setAmbient(new Util.Color4f(0, 1, 0, 1));
stateStart.setDiffuse(new Util.Color4f(0, 1, 0, 1));

var startMesh = Rendering.createCube();
var startGeoNode = new MinSG.GeometryNode();
startGeoNode.moveLocal(path[0]);
startGeoNode.scale(1);
startGeoNode.setMesh(startMesh);
startGeoNode += stateStart;
scene += startGeoNode;

var stateNode = new MinSG.MaterialState;
stateNode.setAmbient(new Util.Color4f(1, 0, 0, 1));
stateNode.setDiffuse(new Util.Color4f(1, 0, 0, 1));

for(var i = 1; i < path.count() - 1; ++i) {
	var nodeMesh = Rendering.createCube();
	var nodeGeoNode = new MinSG.GeometryNode();
	nodeGeoNode.moveLocal(path[i]);
	nodeGeoNode.scale(0.25);
	nodeGeoNode.setMesh(nodeMesh);
	nodeGeoNode += stateNode;
	scene += nodeGeoNode;

	var lineMesh = Rendering.createLine(vd, path[i-1], path[i]);
	var lineGeoNode = new MinSG.GeometryNode();
	lineGeoNode.setMesh(lineMesh);
	lineGeoNode += stateNode;
	scene += lineGeoNode;
}

var nodeMesh = Rendering.createCube();
var nodeGeoNode = new MinSG.GeometryNode();
nodeGeoNode.moveLocal(path[path.count()-1]);
nodeGeoNode.scale(1);
nodeGeoNode.setMesh(nodeMesh);
nodeGeoNode += stateNode;
scene += nodeGeoNode;

var lineMesh = Rendering.createLine(vd, path[path.count()-2], path[path.count()-1]);
var lineGeoNode = new MinSG.GeometryNode();
lineGeoNode.setMesh(lineMesh);
lineGeoNode += stateNode;
scene += lineGeoNode;


// Camera ----------------------------------------------------------------------
var camera = PADrend.getDolly();
camera.setWorldOrigin(new Geometry.Vec3(25,35,25));
camera.rotateToWorldDir(new Geometry.Vec3(0,90,0));
