// Create a new scene
var scene = PADrend.createNewSceneRoot("new MinSG.ListNode");

// activate the scene
PADrend.selectScene(scene);

// Create the ground -----------------------------------------------------------
var vd = new Rendering.VertexDescription;
vd.appendPosition3D(); // 3xfloat (x,y,z)
vd.appendNormalByte(); // 4xbyte (x,y,z,0)
vd.appendColorRGBAByte(); // 4xbyte (r,g,b,a)

var grid = Rendering.createHexGrid(vd, 30, 30, 32, 32);

var scale = 10;
var transform = (new Geometry.Matrix4x4).scale(0.01, 0.01, 0.01); // scale matrix
Rendering.calculateNormals(grid);

var gridNode = new MinSG.GeometryNode(grid);

var stateGrid = new MinSG.MaterialState;
/// RGBA colors for ground
stateGrid.setAmbient(new Util.Color4f(0.1, 0.50, 0.2, 0.8));
stateGrid.setDiffuse(new Util.Color4f(0.1, 0.50, 0.2, 0.8));

gridNode += stateGrid;
scene += gridNode;

// Create obstacles ------------------------------------------------------------
var stateCube = new MinSG.MaterialState;
/// RGBA colors for first obstacle
stateCube.setAmbient(new Util.Color4f(0.46, 0.31, 0.23, 1));
stateCube.setDiffuse(new Util.Color4f(0.46, 0.31, 0.23, 1));

var cubeMesh = Rendering.createCube();
var geoNode = new MinSG.GeometryNode();
geoNode.moveLocal(10, 3, 8);
geoNode.scale(6);

geoNode.setMesh(cubeMesh);
geoNode += stateCube;
scene += geoNode;

var stateCube2 = new MinSG.MaterialState;
/// RGBA colors for second obstacle
stateCube2.setAmbient(new Util.Color4f(0.44, 0.38, 0.18, 1));
//stateCube2.setDiffuse(new Util.Color4f(0.44, 0.38, 0.18, 1));



var cubeMesh2 = Rendering.createRectangle();
var geoNode2 = new MinSG.GeometryNode();
geoNode2.moveLocal(9, 7, 8);
geoNode2.scale(3);
geoNode2.setMesh(cubeMesh2);
geoNode2 += stateCube2;
scene += geoNode2;


// Call the algorithm ----------------------------------------------------------
//Pathfinder.disableOutput();
//Pathfinder.disableOBJ();
//Pathfinder.disableLogging();

// Change start and goal vectors
var start = new Geometry.Vec3(8, 0, 16);
//var goal = new Geometry.Vec3(8, 2, 16);
// If the goal node is on top of cubes
var goal = new Geometry.Vec3(8, 0, 17);
//var goal = new Geometry.Vec3(8, 8, 8);



//Call the pathfinder function
var path = Pathfinder.findPath(scene, start, goal, 1);
Pathfinder.enableOutput();

if(path.count() == 0) {
	path = [start, goal];
}





// Camera ----------------------------------------------------------------------
var camera = PADrend.getDolly();
camera.setWorldOrigin(new Geometry.Vec3(25,35,25));
camera.rotateToWorldDir(new Geometry.Vec3(0,90,0));
