// Create a new scene
var scene = PADrend.createNewSceneRoot("new MinSG.ListNode");

// activate the scene
PADrend.selectScene(scene);

// Create the ground -----------------------------------------------------------
var vd = new Rendering.VertexDescription;
vd.appendPosition3D(); // 3xfloat (x,y,z)
vd.appendNormalByte(); // 4xbyte (x,y,z,0)
vd.appendColorRGBAByte(); // 4xbyte (r,g,b,a)

var grid = Rendering.createHexGrid(vd, 40, 40, 32, 32);

var scale = 10;
var transform = (new Geometry.Matrix4x4).scale(0.01, 0.01, 0.01); // scale matrix
//for(var i = 0; i < 8; ++i) {
//  Rendering.applyNoise(grid, scale *= 0.55, transform.scale(2, 2, 2));
//}
Rendering.calculateNormals(grid);

var gridNode = new MinSG.GeometryNode(grid);

var stateGrid = new MinSG.MaterialState;
stateGrid.setAmbient(new Util.Color4f(0.16, 0.47, 0.19, 1));
stateGrid.setDiffuse(new Util.Color4f(0.16, 0.47, 0.19, 1));

gridNode += stateGrid;
scene += gridNode;


// Create obstacles ------------------------------------------------------------
var stateCube = new MinSG.MaterialState;
stateCube.setAmbient(new Util.Color4f(0.75, 0.58, 0.89, 1));
//stateCube.setDiffuse(new Util.Color4f(0.75, 0.58, 0.89, 1));

var stateCube2 = new MinSG.MaterialState;
stateCube2.setAmbient(new Util.Color4f(0.6, 1, 0.8, 1));
//stateCube2.setDiffuse(new Util.Color4f(0.6, 1, 0.8, 1));

var cubeMesh2 = Rendering.createCube();
var geoNode2 = new MinSG.GeometryNode();
//geoNode2.moveLocal(28.47, 1.45, 10);
geoNode2.moveLocal(28, 0, 10);
//1.7574

geoNode2.scale(6);
geoNode2.setMesh(cubeMesh2);
geoNode2 += stateCube2;
scene += geoNode2;

var cubeMesh = Rendering.createCube();
var geoNode = new MinSG.GeometryNode();
geoNode.moveLocal(22, 0, 10);
geoNode.scale(6);
geoNode.setMesh(cubeMesh);
geoNode += stateCube;
scene += geoNode;


var rot = new Geometry.Vec3();
rot.setX(0);
rot.setY(0);
rot.setZ(45); // Rotate to align edge at 45 degrees
var up = new Geometry.Vec3();
up.setX(1);
up.setY(1);
up.setZ(1);
//geoNode.setRelRotation(rot, up);


// Call the algorithm ----------------------------------------------------------
//Pathfinder.disableOutput();
//Pathfinder.disableOBJ();
//Pathfinder.disableLogging();
//var start = new Geometry.Vec3(26, 3.45, 10);
var start = new Geometry.Vec3(31.3773, 3.46362, 13.3967);
var goal = new Geometry.Vec3(18.5354, 3.42142 ,6.71899);


//var goal = new Geometry.Vec3(20.5, 3.45, 10);

//var start = new Geometry.Vec3(25.9038 ,4.89362 ,10.5146);
//var start = new Geometry.Vec3(24, 3.2987 ,11.0046);
//var start = new Geometry.Vec3(29.0669, 3.375, 10.9988);
//var goal = new Geometry.Vec3(22.5, 3.375, 10.9988);
//var goal = new Geometry.Vec3(5, 0, 10);
var path = Pathfinder.findPath(scene, start, goal, 3);
Pathfinder.enableOutput();

if(path.count() == 0) {
	path = [start, goal];
}


// Draw the found path ---------------------------------------------------------
var stateStart = new MinSG.MaterialState;
stateStart.setAmbient(new Util.Color4f(0, 1, 0, 1));
stateStart.setDiffuse(new Util.Color4f(0, 1, 0, 1));

var startMesh = Rendering.createCube();
var startGeoNode = new MinSG.GeometryNode();
startGeoNode.moveLocal(path[0]);
startGeoNode.scale(1);
startGeoNode.setMesh(startMesh);
startGeoNode += stateStart;
scene += startGeoNode;

var stateNode = new MinSG.MaterialState;
stateNode.setAmbient(new Util.Color4f(1, 0, 0, 1));
stateNode.setDiffuse(new Util.Color4f(1, 0, 0, 1));

for(var i = 1; i < path.count() - 1; ++i) {
	var nodeMesh = Rendering.createCube();
	var nodeGeoNode = new MinSG.GeometryNode();
	nodeGeoNode.moveLocal(path[i]);
	nodeGeoNode.scale(0.25);
	nodeGeoNode.setMesh(nodeMesh);
	nodeGeoNode += stateNode;
	scene += nodeGeoNode;

	var lineMesh = Rendering.createLine(vd, path[i-1], path[i]);
	var lineGeoNode = new MinSG.GeometryNode();
	lineGeoNode.setMesh(lineMesh);
	lineGeoNode += stateNode;
	scene += lineGeoNode;
}

var nodeMesh = Rendering.createCube();
var nodeGeoNode = new MinSG.GeometryNode();
nodeGeoNode.moveLocal(path[path.count()-1]);
nodeGeoNode.scale(1);
nodeGeoNode.setMesh(nodeMesh);
nodeGeoNode += stateNode;
scene += nodeGeoNode;

var lineMesh = Rendering.createLine(vd, path[path.count()-2], path[path.count()-1]);
var lineGeoNode = new MinSG.GeometryNode();
lineGeoNode.setMesh(lineMesh);
lineGeoNode += stateNode;
scene += lineGeoNode;



// Camera ----------------------------------------------------------------------
var camera = PADrend.getDolly();
camera.setWorldOrigin(new Geometry.Vec3(10,7,22));
camera.rotateToWorldDir(new Geometry.Vec3(-20,35,70));
