//
// Created by vinee on 7/25/24.
//

#ifndef BOUNDINGBOX_H
#define BOUNDINGBOX_H

#include "AABB.h"
#include "OBB.h"
#include "Polygon.h"
#include <Geometry/Matrix3x3.h>

namespace Pathfinder {

    class BoundingBox {
    public:
        virtual ~BoundingBox() = default;
    };


    /**
     * @brief Determine if an object is aligned with the world axes.
     *
     * @param object The object to check.
     *
     * @return True if the object is axis-aligned, false otherwise.
     */
    bool isAxisAligned(const Polygon* polygon);
    /**
     * @brief Create an appropriate bounding box (AABB or OBB) based on object orientation.
     *
     * @param object The object to be enclosed in a bounding box.
     *
     * @return A pointer to the newly created bounding box.
     */
    Geometry::BoundingBox* createBoundingBox(const Polygon* polygon);

}

#endif // BOUNDINGBOX_H
