/** 
 * @file
 *
 * @copyright Any copyright is dedicated to the Public Domain.
 *            http://creativecommons.org/publicdomain/zero/1.0
 *            Author: Sascha Brandt <sascha@brandt.graphics> 
 *
 * @brief This file is needed to be able to call the implemented function 
 *        in an EScript script.
 * 
 * @author Sascha Brandt
 */

#ifndef ESCRIPT_HELPER_H
#define ESCRIPT_HELPER_H

#include <functional>

// Forward declaration.
namespace EScript {
	class Namespace;
}

namespace Pathfinder {
	typedef std::function<void (EScript::Namespace* lib)> EScriptInitFunction_t;

	/**
	 * @brief Register the initializer method.
	 */
	bool 
	registerEScriptInit(
		const EScriptInitFunction_t& initFn
	);
} 

#endif
