/**
 * @file
 *
 * @brief This file declares the struct GraphEdge that contains all information
 *        that shall be stored for each edge of a graph.
 * 
 * @author Jan-Luca Hansel
 */

#ifndef GRAPHEDGE_H
#define GRAPHEDGE_H

namespace Pathfinder {

	/**
	 * @brief This struct declares all infromation that shall be stored for 
	 *        each edge of a graph.
	 */
	struct GraphEdge {

		/**
		 * The distance between the two endpoints of an edge.
		 */
		float distance; 


		/** 
		 * A number that indicates which agent is able to traverse this edge.
		 */
		short drivability;

        /**
         * The weight of traversing edge
         */
        float edge_weight;

        /**
         * The weight of traversing edge
         */
        char edge_type;

	};

}

#endif
