/** 
 * @file
 *
 * @brief This file declares the struct Line3Unnorm that inherits from Line3.
 *        Its a Line3 with a non-normalized direction vector.
 *
 * @author Jan-Luca Hansel
 */

#ifndef LINE3UNNORM_H
#define LINE3UNNORM_H

#include "Line3.h"

namespace Pathfinder {

	/**
	 * @brief This struct represents a line of the form u = v + rw
	 *        where ||w|| = 1 does not neccessarily hold.
	 */
	struct Line3Unnorm : Line3 {

		/**
		 * @brief A constructor that creates a line from two vectors.
		 *
		 * @param a The support vector.
		 * @param b The direction vector.
		 */
		Line3Unnorm(
			Geometry::Vec3 a, 
			Geometry::Vec3 b
		);

	};

}

#endif
