/** 
 * @file
 *
 * @brief This file implements all functionality declared in Plane.h.
 *
 * @author Jan-Luca Hansel
 */

#include "Plane.h"
#include "Vec.h"

namespace Pathfinder {

	Plane::Plane(
		const float& a, 
		const float& b, 
		const float& c, 
		const float& d
	) : 
		a(a), 
		b(b), 
		c(c), 
		d(d) {} 

	Plane::Plane(
		const Geometry::Vec3& u, 
		const Geometry::Vec3& v, 
		const Geometry::Vec3& w) 
	{
		Geometry::Vec3 ixj = Polygon::polygonNormal(u, v, w);
		this->a = ixj[x];
		this->b = ixj[y];
		this->c = ixj[z];
		this->d = -dotProduct(ixj, u, 0);
	}

}
