/*
	This file is part of the GUI library.
	Copyright (C) 2008-2012 Benjamin Eikel <benjamin@eikel.org>
	Copyright (C) 2008-2012 Claudius Jähn <claudius@uni-paderborn.de>
	Copyright (C) 2008-2012 Ralf Petring <ralf@petring.net>
	
	This library is subject to the terms of the Mozilla Public License, v. 2.0.
	You should have received a copy of the MPL along with this library; see the 
	file LICENSE. If not, you can obtain one at http://mozilla.org/MPL/2.0/.
*/
#ifndef GUI_COLORS_H
#define GUI_COLORS_H

#include <Util/Graphics/Color.h>

namespace GUI{

namespace Colors{

extern const Util::Color4ub ACTIVE_TITLE_BG_COLOR_1;
extern const Util::Color4ub ACTIVE_TITLE_BG_COLOR_2;
extern const Util::Color4ub WINDOW_BG_ACTIVE;
extern const Util::Color4ub WINDOW_BG_PASSIVE;
extern const Util::Color4ub TITLE_BG_COLOR_1;
extern const Util::Color4ub TITLE_BG_COLOR_2;
extern const Util::Color4ub TITLE_TEXT_COLOR;

extern const Util::Color4ub SELECT_COLOR;
extern const Util::Color4ub COMPONENT_COLOR_1;
extern const Util::Color4ub COMPONENT_COLOR_2;
extern const Util::Color4ub BRIGHT_COLOR;
extern const Util::Color4ub LIGHT_BRIGHT_COLOR;
extern const Util::Color4ub DARK_COLOR;
extern const Util::Color4ub BORDER_COLOR;
extern const Util::Color4ub LIGHT_BORDER_COLOR;
extern const Util::Color4ub TEXT_COLOR;
extern const Util::Color4ub LIGHT_TEXT_COLOR;
extern const Util::Color4ub SELECTED_TEXT_BG;
extern const Util::Color4ub ALMOST_BLACK_COLOR;

extern const Util::Color4ub TRANSPARENT_COLOR;

extern const Util::Color4ub ACTIVE_COLOR_1;
extern const Util::Color4ub ACTIVE_COLOR_2;
extern const Util::Color4ub ACTIVE_COLOR_3;
extern const Util::Color4ub ACTIVE_COLOR_4;
extern const Util::Color4ub PASSIVE_COLOR_1;
extern const Util::Color4ub PASSIVE_COLOR_2;
extern const Util::Color4ub PASSIVE_COLOR_3;

extern const Util::Color4ub PASSIVE_COLOR_4;

extern const Util::Color4ub TEXTFIELD_BG;
extern const Util::Color4ub TEXTFIELD_BORDER;

extern const Util::Color4ub BUTTON_BG_1;
extern const Util::Color4ub BUTTON_BG_2;


}

}
#endif // GUI_COLORS_H
